import { createElement, useRef, useEffect } from 'react';
import { __rest } from 'tslib';
import { highlightWidgetManager } from '@puzzlelabs/puzzle-glossary';

const PageWidget = props => {
    return createElement('page-widget', props);
};

const HighlightZone = (_a) => {
    var { as = 'span' } = _a, props = __rest(_a, ["as"]);
    const ref = useRef();
    const mark = () => highlightWidgetManager.ready && highlightWidgetManager.mark([ref.current]);
    useEffect(() => highlightWidgetManager.subscribe(mark), []);
    useEffect(() => mark, [props.children]);
    return createElement(as, Object.assign(Object.assign({}, props), { ref, onInput: event => {
            var _a;
            (_a = props.onInput) === null || _a === void 0 ? void 0 : _a.call(props, event);
            mark();
        } }));
};

export { HighlightZone, PageWidget };
